Index: src/analysis_correlation.cpp
===================================================================
--- src/analysis_correlation.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/analysis_correlation.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,6 +15,8 @@
 #include "tesselation.hpp"
 #include "tesselationhelpers.hpp"
+#include "triangleintersectionlist.hpp"
 #include "vector.hpp"
 #include "verbose.hpp"
+#include "World.hpp"
 
 
@@ -34,5 +36,5 @@
 
   if (molecules->ListOfMolecules.empty()) {
-    eLog() << Verbose(1) <<"No molecule given." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) <<"No molecule given." << endl);
     return outmap;
   }
@@ -40,20 +42,20 @@
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
-      eLog() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
+      atom *Walker = (*MolWalker)->start;
+      while (Walker->next != (*MolWalker)->end) {
+        Walker = Walker->next;
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
         if ((type1 == NULL) || (Walker->type == type1)) {
           for (MoleculeList::const_iterator MolOtherWalker = MolWalker; MolOtherWalker != molecules->ListOfMolecules.end(); MolOtherWalker++)
             if ((*MolOtherWalker)->ActiveFlag) {
-              Log() << Verbose(2) << "Current other molecule is " << *MolOtherWalker << "." << endl;
+              DoLog(2) && (Log() << Verbose(2) << "Current other molecule is " << *MolOtherWalker << "." << endl);
               atom *OtherWalker = (*MolOtherWalker)->start;
               while (OtherWalker->next != (*MolOtherWalker)->end) { // only go up to Walker
                 OtherWalker = OtherWalker->next;
-                Log() << Verbose(3) << "Current otheratom is " << *OtherWalker << "." << endl;
+                DoLog(3) && (Log() << Verbose(3) << "Current otheratom is " << *OtherWalker << "." << endl);
                 if (Walker->nr < OtherWalker->nr)
                   if ((type2 == NULL) || (OtherWalker->type == type2)) {
-                    distance = Walker->node->PeriodicDistance(OtherWalker->node, (*MolWalker)->cell_size);
+                    distance = Walker->node->PeriodicDistance(*OtherWalker->node, World::getInstance().getDomain());
                     //Log() << Verbose(1) <<"Inserting " << *Walker << " and " << *OtherWalker << endl;
                     outmap->insert ( pair<double, pair <atom *, atom*> > (distance, pair<atom *, atom*> (Walker, OtherWalker) ) );
@@ -90,5 +92,5 @@
 
   if (molecules->ListOfMolecules.empty()) {
-    eLog() << Verbose(1) <<"No molecule given." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) <<"No molecule given." << endl);
     return outmap;
   }
@@ -96,13 +98,13 @@
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
-      double * FullMatrix = ReturnFullMatrixforSymmetric((*MolWalker)->cell_size);
+      double * FullMatrix = ReturnFullMatrixforSymmetric(World::getInstance().getDomain());
       double * FullInverseMatrix = InverseMatrix(FullMatrix);
-      eLog() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl;
+      DoeLog(2) && (eLog()<< Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
+      atom *Walker = (*MolWalker)->start;
+      while (Walker->next != (*MolWalker)->end) {
+        Walker = Walker->next;
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
         if ((type1 == NULL) || (Walker->type == type1)) {
-          periodicX.CopyVector(Walker->node);
+          periodicX = *(Walker->node);
           periodicX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
           // go through every range in xyz and get distance
@@ -110,17 +112,16 @@
             for (n[1]=-ranges[1]; n[1] <= ranges[1]; n[1]++)
               for (n[2]=-ranges[2]; n[2] <= ranges[2]; n[2]++) {
-                checkX.Init(n[0], n[1], n[2]);
-                checkX.AddVector(&periodicX);
+                checkX = Vector(n[0], n[1], n[2]) + periodicX;
                 checkX.MatrixMultiplication(FullMatrix);
                 for (MoleculeList::const_iterator MolOtherWalker = MolWalker; MolOtherWalker != molecules->ListOfMolecules.end(); MolOtherWalker++)
                   if ((*MolOtherWalker)->ActiveFlag) {
-                    Log() << Verbose(2) << "Current other molecule is " << *MolOtherWalker << "." << endl;
+                    DoLog(2) && (Log() << Verbose(2) << "Current other molecule is " << *MolOtherWalker << "." << endl);
                     atom *OtherWalker = (*MolOtherWalker)->start;
                     while (OtherWalker->next != (*MolOtherWalker)->end) { // only go up to Walker
                       OtherWalker = OtherWalker->next;
-                      Log() << Verbose(3) << "Current otheratom is " << *OtherWalker << "." << endl;
+                      DoLog(3) && (Log() << Verbose(3) << "Current otheratom is " << *OtherWalker << "." << endl);
                       if (Walker->nr < OtherWalker->nr)
                         if ((type2 == NULL) || (OtherWalker->type == type2)) {
-                          periodicOtherX.CopyVector(OtherWalker->node);
+                          periodicOtherX = *(OtherWalker->node);
                           periodicOtherX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
                           // go through every range in xyz and get distance
@@ -128,8 +129,7 @@
                             for (Othern[1]=-ranges[1]; Othern[1] <= ranges[1]; Othern[1]++)
                               for (Othern[2]=-ranges[2]; Othern[2] <= ranges[2]; Othern[2]++) {
-                                checkOtherX.Init(Othern[0], Othern[1], Othern[2]);
-                                checkOtherX.AddVector(&periodicOtherX);
+                                checkOtherX = Vector(Othern[0], Othern[1], Othern[2]) + periodicOtherX;
                                 checkOtherX.MatrixMultiplication(FullMatrix);
-                                distance = checkX.Distance(&checkOtherX);
+                                distance = checkX.distance(checkOtherX);
                                 //Log() << Verbose(1) <<"Inserting " << *Walker << " and " << *OtherWalker << endl;
                                 outmap->insert ( pair<double, pair <atom *, atom*> > (distance, pair<atom *, atom*> (Walker, OtherWalker) ) );
@@ -162,5 +162,5 @@
 
   if (molecules->ListOfMolecules.empty()) {
-    Log() << Verbose(1) <<"No molecule given." << endl;
+    DoLog(1) && (Log() << Verbose(1) <<"No molecule given." << endl);
     return outmap;
   }
@@ -168,12 +168,12 @@
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
-      Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
+      atom *Walker = (*MolWalker)->start;
+      while (Walker->next != (*MolWalker)->end) {
+        Walker = Walker->next;
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
         if ((type == NULL) || (Walker->type == type)) {
-          distance = Walker->node->PeriodicDistance(point, (*MolWalker)->cell_size);
-          Log() << Verbose(4) << "Current distance is " << distance << "." << endl;
+          distance = Walker->node->PeriodicDistance(*point, World::getInstance().getDomain());
+          DoLog(4) && (Log() << Verbose(4) << "Current distance is " << distance << "." << endl);
           outmap->insert ( pair<double, pair<atom *, const Vector*> >(distance, pair<atom *, const Vector*> (Walker, point) ) );
         }
@@ -202,5 +202,5 @@
 
   if (molecules->ListOfMolecules.empty()) {
-    Log() << Verbose(1) <<"No molecule given." << endl;
+    DoLog(1) && (Log() << Verbose(1) <<"No molecule given." << endl);
     return outmap;
   }
@@ -208,13 +208,13 @@
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
-      double * FullMatrix = ReturnFullMatrixforSymmetric((*MolWalker)->cell_size);
+      double * FullMatrix = ReturnFullMatrixforSymmetric(World::getInstance().getDomain());
       double * FullInverseMatrix = InverseMatrix(FullMatrix);
-      Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
+      atom *Walker = (*MolWalker)->start;
+      while (Walker->next != (*MolWalker)->end) {
+        Walker = Walker->next;
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
         if ((type == NULL) || (Walker->type == type)) {
-          periodicX.CopyVector(Walker->node);
+          periodicX = *(Walker->node);
           periodicX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
           // go through every range in xyz and get distance
@@ -222,9 +222,8 @@
             for (n[1]=-ranges[1]; n[1] <= ranges[1]; n[1]++)
               for (n[2]=-ranges[2]; n[2] <= ranges[2]; n[2]++) {
-                checkX.Init(n[0], n[1], n[2]);
-                checkX.AddVector(&periodicX);
+                checkX = Vector(n[0], n[1], n[2]) + periodicX;
                 checkX.MatrixMultiplication(FullMatrix);
-                distance = checkX.Distance(point);
-                Log() << Verbose(4) << "Current distance is " << distance << "." << endl;
+                distance = checkX.distance(*point);
+                DoLog(4) && (Log() << Verbose(4) << "Current distance is " << distance << "." << endl);
                 outmap->insert ( pair<double, pair<atom *, const Vector*> >(distance, pair<atom *, const Vector*> (Walker, point) ) );
               }
@@ -255,5 +254,5 @@
 
   if ((Surface == NULL) || (LC == NULL) || (molecules->ListOfMolecules.empty())) {
-    Log() << Verbose(1) <<"No Tesselation, no LinkedCell or no molecule given." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) <<"No Tesselation, no LinkedCell or no molecule given." << endl);
     return outmap;
   }
@@ -261,18 +260,18 @@
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
-      Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Current molecule is " << (*MolWalker)->name << "." << endl);
+      atom *Walker = (*MolWalker)->start;
+      while (Walker->next != (*MolWalker)->end) {
+        Walker = Walker->next;
+        //Log() << Verbose(1) << "Current atom is " << *Walker << "." << endl;
         if ((type == NULL) || (Walker->type == type)) {
-          triangle = Surface->FindClosestTriangleToVector(Walker->node, LC );
-          if (triangle != NULL) {
-            distance = DistanceToTrianglePlane(Walker->node, triangle);
-            outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(distance, pair<atom *, BoundaryTriangleSet*> (Walker, triangle) ) );
-          }
-        }
-      }
-    }
+          TriangleIntersectionList Intersections(Walker->node,Surface,LC);
+          distance = Intersections.GetSmallestDistance();
+          triangle = Intersections.GetClosestTriangle();
+          outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(distance, pair<atom *, BoundaryTriangleSet*> (Walker, triangle) ) );
+        }
+      }
+    } else
+      DoLog(1) && (Log() << Verbose(1) << "molecule " << (*MolWalker)->name << " is not active." << endl);
 
   return outmap;
@@ -304,5 +303,5 @@
 
   if ((Surface == NULL) || (LC == NULL) || (molecules->ListOfMolecules.empty())) {
-    Log() << Verbose(1) <<"No Tesselation, no LinkedCell or no molecule given." << endl;
+    DoLog(1) && (Log() << Verbose(1) <<"No Tesselation, no LinkedCell or no molecule given." << endl);
     return outmap;
   }
@@ -312,13 +311,13 @@
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
-      double * FullMatrix = ReturnFullMatrixforSymmetric((*MolWalker)->cell_size);
+      double * FullMatrix = ReturnFullMatrixforSymmetric(World::getInstance().getDomain());
       double * FullInverseMatrix = InverseMatrix(FullMatrix);
-      Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
+      atom *Walker = (*MolWalker)->start;
+      while (Walker->next != (*MolWalker)->end) {
+        Walker = Walker->next;
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
         if ((type == NULL) || (Walker->type == type)) {
-          periodicX.CopyVector(Walker->node);
+          periodicX = *(Walker->node);
           periodicX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
           // go through every range in xyz and get distance
@@ -327,9 +326,9 @@
             for (n[1]=-ranges[1]; n[1] <= ranges[1]; n[1]++)
               for (n[2]=-ranges[2]; n[2] <= ranges[2]; n[2]++) {
-                checkX.Init(n[0], n[1], n[2]);
-                checkX.AddVector(&periodicX);
+                checkX = Vector(n[0], n[1], n[2]) + periodicX;
                 checkX.MatrixMultiplication(FullMatrix);
-                triangle = Surface->FindClosestTriangleToVector(&checkX, LC);
-                distance = Surface->GetDistanceSquaredToTriangle(checkX, triangle);
+                TriangleIntersectionList Intersections(&checkX,Surface,LC);
+                distance = Intersections.GetSmallestDistance();
+                triangle = Intersections.GetClosestTriangle();
                 if ((ShortestDistance == -1.) || (distance < ShortestDistance)) {
                   ShortestDistance = distance;
@@ -338,5 +337,4 @@
               }
           // insert
-          ShortestDistance = sqrt(ShortestDistance);
           outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(ShortestDistance, pair<atom *, BoundaryTriangleSet*> (Walker, ShortestTriangle) ) );
           //Log() << Verbose(1) << "INFO: Inserting " << Walker << " with distance " << ShortestDistance << " to " << *ShortestTriangle << "." << endl;
@@ -350,14 +348,14 @@
 };
 
-/** Returns the start of the bin for a given value.
+/** Returns the index of the bin for a given value.
  * \param value value whose bin to look for
  * \param BinWidth width of bin
  * \param BinStart first bin
  */
-double GetBin ( const double value, const double BinWidth, const double BinStart )
-{
-  Info FunctionInfo(__func__);
-  double bin =(double) (floor((value - BinStart)/BinWidth));
-  return (bin*BinWidth+BinStart);
+int GetBin ( const double value, const double BinWidth, const double BinStart )
+{
+  Info FunctionInfo(__func__);
+  int bin =(int) (floor((value - BinStart)/BinWidth));
+  return (bin);
 };
 
@@ -372,5 +370,5 @@
   *file << "BinStart\tCount" << endl;
   for (BinPairMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
-    *file << runner->first << "\t" << runner->second << endl;
+    *file << setprecision(8) << runner->first << "\t" << runner->second << endl;
   }
 };
@@ -385,5 +383,5 @@
   *file << "BinStart\tAtom1\tAtom2" << endl;
   for (PairCorrelationMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
-    *file << runner->first << "\t" << *(runner->second.first) << "\t" << *(runner->second.second) << endl;
+    *file << setprecision(8) << runner->first << "\t" << *(runner->second.first) << "\t" << *(runner->second.second) << endl;
   }
 };
@@ -400,5 +398,5 @@
     *file << runner->first;
     for (int i=0;i<NDIM;i++)
-      *file << "\t" << (runner->second.first->node->x[i] - runner->second.second->x[i]);
+      *file << "\t" << setprecision(8) << (runner->second.first->node->at(i) - runner->second.second->at(i));
     *file << endl;
   }
@@ -413,7 +411,8 @@
   Info FunctionInfo(__func__);
   *file << "BinStart\tTriangle" << endl;
-  for (CorrelationToSurfaceMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
-    *file << runner->first << "\t" << *(runner->second.first) << "\t" << *(runner->second.second) << endl;
-  }
-};
-
+  if (!map->empty())
+    for (CorrelationToSurfaceMap::const_iterator runner = map->begin(); runner != map->end(); ++runner) {
+      *file << setprecision(8) << runner->first << "\t" << *(runner->second.first) << "\t" << *(runner->second.second) << endl;
+    }
+};
+
Index: src/analysis_correlation.hpp
===================================================================
--- src/analysis_correlation.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/analysis_correlation.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -51,5 +51,5 @@
 CorrelationToPointMap *PeriodicCorrelationToPoint(MoleculeListClass * const &molecules, const element * const type, const Vector *point, const int ranges[NDIM] );
 CorrelationToSurfaceMap *PeriodicCorrelationToSurface(MoleculeListClass * const &molecules, const element * const type, const Tesselation * const Surface, const LinkedCell *LC, const int ranges[NDIM] );
-double GetBin ( const double value, const double BinWidth, const double BinStart );
+int GetBin ( const double value, const double BinWidth, const double BinStart );
 void OutputCorrelation( ofstream * const file, const BinPairMap * const map );
 void OutputPairCorrelation( ofstream * const file, const PairCorrelationMap * const map );
@@ -71,5 +71,5 @@
 
   if (map == NULL) {
-    eLog() << Verbose(0) << "Nothing to min/max, map is NULL!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Nothing to min/max, map is NULL!" << endl);
     performCriticalExit();
     return;
@@ -103,5 +103,5 @@
 {
   BinPairMap *outmap = new BinPairMap;
-  double bin = 0.;
+  int bin = 0;
   double start = 0.;
   double end = 0.;
@@ -109,5 +109,5 @@
 
   if (map == NULL) {
-    eLog() << Verbose(0) << "Nothing to bin, is NULL!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Nothing to bin, is NULL!" << endl);
     performCriticalExit();
     return outmap;
@@ -122,11 +122,11 @@
     start = BinStart;
     end = BinEnd;
-    for (double runner = start; runner <= end; runner += BinWidth)
-      outmap->insert( pair<double, int> (runner, 0) );
   }
+  for (int runner = 0; runner <= ceil((end-start)/BinWidth); runner++)
+    outmap->insert( pair<double, int> ((double)runner*BinWidth+start, 0) );
 
   for (typename T::iterator runner = map->begin(); runner != map->end(); ++runner) {
     bin = GetBin (runner->first, BinWidth, start);
-    BinPairMapInserter = outmap->insert ( pair<double, int> (bin, 1) );
+    BinPairMapInserter = outmap->insert ( pair<double, int> ((double)bin*BinWidth+start, 1) );
     if (!BinPairMapInserter.second) {  // bin already present, increase
       BinPairMapInserter.first->second += 1;
Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/analyzer.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -63,14 +63,14 @@
   int counter = 0;
 
-  Log() << Verbose(0) << "ANOVA Analyzer" << endl;
-  Log() << Verbose(0) << "==============" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "ANOVA Analyzer" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "==============" << endl);
 
   // Get the command line options
   if (argc < 4) {
-    Log() << Verbose(0) << "Usage: " << argv[0] << " <inputdir> <prefix> <outputdir> [elementsdb]" << endl;
-    Log() << Verbose(0) << "<inputdir>\ttherein the output of a molecuilder fragmentation is expected, each fragment with a subdir containing an energy.all and a forces.all file." << endl;
-    Log() << Verbose(0) << "<prefix>\tprefix of energy and forces file." << endl;
-    Log() << Verbose(0) << "<outputdir>\tcreated plotfiles and datafiles are placed into this directory " << endl;
-    Log() << Verbose(0) << "[elementsdb]\tpath to elements database, needed for shieldings." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Usage: " << argv[0] << " <inputdir> <prefix> <outputdir> [elementsdb]" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "<inputdir>\ttherein the output of a molecuilder fragmentation is expected, each fragment with a subdir containing an energy.all and a forces.all file." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "<prefix>\tprefix of energy and forces file." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "<outputdir>\tcreated plotfiles and datafiles are placed into this directory " << endl);
+    DoLog(0) && (Log() << Verbose(0) << "[elementsdb]\tpath to elements database, needed for shieldings." << endl);
     return 1;
   } else {
@@ -81,5 +81,5 @@
 
   if (argc > 4) {
-    Log() << Verbose(0) << "Loading periodentafel." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Loading periodentafel." << endl);
     periode = Malloc<periodentafel>(1, "main - periode");
     periode->LoadPeriodentafel(argv[4]);
@@ -96,5 +96,5 @@
   if (!Hcorrection.ParseFragmentMatrix(argv[1], "", HCORRECTIONSUFFIX,0,0)) {
     NoHCorrection = true;
-    eLog() << Verbose(2) << "No HCorrection file found, skipping these." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "No HCorrection file found, skipping these." << endl);
   }
   
@@ -102,9 +102,9 @@
   if (!Hessian.ParseFragmentMatrix(argv[1], dir, HessianSuffix,0,0)) {
     NoHessian = true;
-    eLog() << Verbose(2) << "No Hessian file found, skipping these." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "No Hessian file found, skipping these." << endl);
   }
   if (!Time.ParseFragmentMatrix(argv[1], dir, TimeSuffix, 10,1)) {
     NoTime = true;
-    eLog() << Verbose(2) << "No speed file found, skipping these." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "No speed file found, skipping these." << endl);
   }
   if (periode != NULL) { // also look for PAS values
@@ -248,5 +248,5 @@
   // +++++++++++++++ ANALYZING ++++++++++++++++++++++++++++++
 
-  Log() << Verbose(0) << "Analyzing ..." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Analyzing ..." << endl);
 
   // ======================================= Creating the data files ==============================================================
@@ -559,5 +559,5 @@
   delete(periode);
   Free(&dir);
-  Log() << Verbose(0) << "done." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done." << endl);
   return 0;
 };
Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/atom.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -20,7 +20,7 @@
 /** Constructor of class atom.
  */
-atom::atom() : previous(NULL), next(NULL), father(this), sort(&nr)
-{
-  World::get()->registerAtom(this);
+atom::atom() :
+  previous(NULL), next(NULL), father(this), sort(&nr)
+{
   node = &x;  // TesselPoint::x can only be referenced from here
 };
@@ -28,14 +28,30 @@
 /** Constructor of class atom.
  */
-atom::atom(atom *pointer) : previous(NULL), next(NULL), father(pointer), sort(&nr)
-{
-  World::get()->registerAtom(this);
+atom::atom(atom *pointer) :
+    ParticleInfo(pointer),
+    previous(NULL), next(NULL), father(pointer), sort(&nr)
+{
   type = pointer->type;  // copy element of atom
-  x.CopyVector(&pointer->x); // copy coordination
-  v.CopyVector(&pointer->v); // copy velocity
+  x = pointer->x; // copy coordination
+  v = pointer->v; // copy velocity
   FixedIon = pointer->FixedIon;
   node = &x;
 };
 
+atom *atom::clone(){
+  atom *res = new atom();
+  res->previous=0;
+  res->next=0;
+  res->father = this;
+  res->sort = &res->nr;
+  res->type = type;
+  res->x = this->x;
+  res->v = this->v;
+  res->FixedIon = FixedIon;
+  res->node = &x;
+  World::getInstance().registerAtom(res);
+  return res;
+}
+
 
 /** Destructor of class atom.
@@ -43,5 +59,4 @@
 atom::~atom()
 {
-  World::get()->unregisterAtom(this);
   unlink(this);
 };
@@ -115,8 +130,8 @@
   if (out != NULL) {
     *out << "Ion_Type" << ElementNo << "_" << AtomNo << "\t"  << fixed << setprecision(9) << showpoint;
-    *out << x.x[0] << "\t" << x.x[1] << "\t" << x.x[2];
+    *out << x[0] << "\t" << x[1] << "\t" << x[2];
     *out << "\t" << FixedIon;
     if (v.Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << v.x[0] << "\t" << v.x[1] << "\t" << v.x[2] << "\t";
+      *out << "\t" << scientific << setprecision(6) << v[0] << "\t" << v[1] << "\t" << v[2] << "\t";
     if (comment != NULL)
       *out << " # " << comment << endl;
@@ -140,8 +155,8 @@
   if (out != NULL) {
     *out << "Ion_Type" << ElementNo[type->Z] << "_" << AtomNo[type->Z] << "\t"  << fixed << setprecision(9) << showpoint;
-    *out << x.x[0] << "\t" << x.x[1] << "\t" << x.x[2];
+    *out << x[0] << "\t" << x[1] << "\t" << x[2];
     *out << "\t" << FixedIon;
     if (v.Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << v.x[0] << "\t" << v.x[1] << "\t" << v.x[2] << "\t";
+      *out << "\t" << scientific << setprecision(6) << v[0] << "\t" << v[1] << "\t" << v[2] << "\t";
     if (comment != NULL)
       *out << " # " << comment << endl;
@@ -160,5 +175,5 @@
 {
   if (out != NULL) {
-    *out << type->symbol << "\t" << x.x[0] << "\t" << x.x[1] << "\t" << x.x[2] << "\t" << endl;
+    *out << type->symbol << "\t" << x[0] << "\t" << x[1] << "\t" << x[2] << "\t" << endl;
     return true;
   } else
@@ -178,10 +193,10 @@
   if (out != NULL) {
     *out << "Ion_Type" << ElementNo[type->Z] << "_" << AtomNo[type->Z] << "\t"  << fixed << setprecision(9) << showpoint;
-    *out << Trajectory.R.at(step).x[0] << "\t" << Trajectory.R.at(step).x[1] << "\t" << Trajectory.R.at(step).x[2];
+    *out << Trajectory.R.at(step)[0] << "\t" << Trajectory.R.at(step)[1] << "\t" << Trajectory.R.at(step)[2];
     *out << "\t" << FixedIon;
     if (Trajectory.U.at(step).Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << Trajectory.U.at(step).x[0] << "\t" << Trajectory.U.at(step).x[1] << "\t" << Trajectory.U.at(step).x[2] << "\t";
+      *out << "\t" << scientific << setprecision(6) << Trajectory.U.at(step)[0] << "\t" << Trajectory.U.at(step)[1] << "\t" << Trajectory.U.at(step)[2] << "\t";
     if (Trajectory.F.at(step).Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << Trajectory.F.at(step).x[0] << "\t" << Trajectory.F.at(step).x[1] << "\t" << Trajectory.F.at(step).x[2] << "\t";
+      *out << "\t" << scientific << setprecision(6) << Trajectory.F.at(step)[0] << "\t" << Trajectory.F.at(step)[1] << "\t" << Trajectory.F.at(step)[2] << "\t";
     *out << "\t# Number in molecule " << nr << endl;
     return true;
@@ -199,7 +214,7 @@
   if (out != NULL) {
     *out << type->symbol << "\t";
-    *out << Trajectory.R.at(step).x[0] << "\t";
-    *out << Trajectory.R.at(step).x[1] << "\t";
-    *out << Trajectory.R.at(step).x[2] << endl;
+    *out << Trajectory.R.at(step)[0] << "\t";
+    *out << Trajectory.R.at(step)[1] << "\t";
+    *out << Trajectory.R.at(step)[2] << endl;
     return true;
   } else
@@ -214,5 +229,5 @@
 void atom::OutputMPQCLine(ofstream * const out, const Vector *center, int *AtomNo = NULL) const
 {
-  *out << "\t\t" << type->symbol << " [ " << x.x[0]-center->x[0] << "\t" << x.x[1]-center->x[1] << "\t" << x.x[2]-center->x[2] << " ]" << endl;
+  *out << "\t\t" << type->symbol << " [ " << x[0]-center->at(0) << "\t" << x[1]-center->at(1) << "\t" << x[2]-center->at(2) << " ]" << endl;
   if (AtomNo != NULL)
     *AtomNo++;
@@ -237,5 +252,5 @@
 double atom::DistanceSquaredToVector(const Vector &origin) const
 {
-  return origin.DistanceSquared(&x);
+  return origin.DistanceSquared(x);
 };
 
@@ -246,5 +261,5 @@
 double atom::DistanceToVector(const Vector &origin) const
 {
-  return origin.Distance(&x);
+  return origin.distance(x);
 };
 
@@ -267,2 +282,39 @@
 };
 
+World *atom::getWorld(){
+  return world;
+}
+
+void atom::setWorld(World* _world){
+  world = _world;
+}
+
+bool atom::changeId(atomId_t newId){
+  // first we move ourselves in the world
+  // the world lets us know if that succeeded
+  if(world->changeAtomId(id,newId,this)){
+    id = newId;
+    return true;
+  }
+  else{
+    return false;
+  }
+}
+
+void atom::setId(atomId_t _id) {
+  id=_id;
+}
+
+atomId_t atom::getId() {
+  return id;
+}
+
+atom* NewAtom(atomId_t _id){
+  atom * res =new atom();
+  res->setId(_id);
+  return res;
+}
+
+void DeleteAtom(atom* atom){
+  delete atom;
+}
